// Smart Align (Freestyler)
// Version 0.1
// (c) vd
// ai-js@mail.ru

// BECAUSE THE SCRIPT IS DISTRIBUTED FREE OF CHARGE, THERE IS NO
// WARRANTY FOR THE SCRIPT, TO THE EXTENT PERMITTED BY APPLICABLE
// LAW. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE 
// SCRIPT IS WITH YOU. SHOULD THE SCRIPT PROVE DEFECTIVE, YOU 
// ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 


alignType = 'bottom';
mySelection = activeDocument.selection;
if ((mySelection instanceof Array) && (mySelection.length > 0)) {
	if (mySelection.length > 1) {
		anchorBounds = getPosition(mySelection[0]);
		for (j=0; j<mySelection.length; j++) for ( k=0; k<mySelection[j].tags.length; k++ )
			if( mySelection[j].tags[k].name == '_anchorTag' ) anchorBounds = getPosition(mySelection[j]);
		for (j=0; j<mySelection.length; j++) {
			objBounds = getPosition(mySelection[j]);		
			mySelection[j].top += anchorBounds[alignType] - objBounds[alignType];
		}	
	}
	else {
		anchorBounds = getDocPosition();
		objBounds = getPosition(mySelection[0]);		
		mySelection[0].top += anchorBounds[alignType] - objBounds[alignType];
	}
}

function getBounds(obj) {
	var vbounds = new Array();

	if( obj.typename == 'TextFrame' ) {
		objcopy=obj.duplicate().createOutline();
		vbounds = objcopy.visibleBounds;
		objcopy.remove();
	}
	else if( (obj.typename == 'GroupItem') && !obj.clipped ) {
		vbounds = getBounds(obj.pageItems[0]);
		for( n=1; n<obj.pageItems.length; n++  ) {
			vgb = getBounds(obj.pageItems[n]);
			if( vbounds[0] > vgb[0] ) vbounds[0] = vgb[0];
			if( vbounds[1] < vgb[1] ) vbounds[1] = vgb[1];
			if( vbounds[2] < vgb[2] ) vbounds[2] = vgb[2];
			if( vbounds[3] > vgb[3] ) vbounds[3] = vgb[3];
		}
	}
	else if( (obj.typename == 'GroupItem') && obj.clipped && (obj.pageItems.length > 1) ) {
		vbounds = getBounds(obj.pageItems[0]);
		
		cvgb = getBounds(obj.pageItems[1]);
		objleft = cvgb[0];
		objtop = cvgb[1];
		objright = cvgb[2];
		objbottom = cvgb[3];
		
		obj.pageItems[0].stroked ? so = 0 : so = 1;
		for( n=so; n<obj.pageItems.length; n++ ) {
			cvgb = getBounds(obj.pageItems[n]);
			if( objleft > cvgb[0] ) objleft = cvgb[0];
			if( objtop < cvgb[1] ) objtop = cvgb[1];
			if( objright < (cvgb[2]) ) objright = cvgb[2];
			if( objbottom > (cvgb[3]) ) objbottom = cvgb[3];
		}
		if( vbounds[0] < objleft ) vbounds[0] = objleft;
		if( vbounds[1] > objtop ) vbounds[1] = objtop;
		if( vbounds[2] > objright ) vbounds[2] = objright;
		if( vbounds[3] < objbottom ) vbounds[3] = objbottom;
	}
	else {
		vbounds = obj.visibleBounds;
	}

	return vbounds;
}

function getPosition(obj) {
	var b = new Array();

	bnds = getBounds(obj);
	b['left']	= bnds[0];
	b['top']	= bnds[1];
	b['right']	= bnds[2];
	b['bottom']	= bnds[3];
	b['centerX']	= bnds[0] + (bnds[2]-bnds[0])/2;
	b['centerY']	= bnds[1] - (bnds[1]-bnds[3])/2;

	return b;
}

function getDocPosition() {
	var b = new Array();

	doc = activeDocument;
	var origin = doc.rulerOrigin;
	b['left']	= -origin[0];
	b['top']	= -origin[1] + doc.height;
	b['right']	= -origin[0] + doc.width;
	b['bottom']	= -origin[1];
	b['centerX']	= -origin[0] + doc.width/2;
	b['centerY']	= -origin[1] + doc.height/2;


	return b;
}
